<?php
/*
Plugin Name:  Zy Coder
Plugin URI:   https://innovawer.com/zycoder/
Description:  Insert Files & Snippets of PHP|HTML|JS|CSS|CMD Code
Author:       Innovawer
Author URI:   https://innovawer.com
Version:      1.0.1
License:      GPL-2.0-or-later
License URI:  license.txt
Text Domain:  zycoder
Requires PHP: 5.6
Requires at least: 3.6
*/

function arrKey($key, $atts){
    $ret=false;
    if(is_array($atts)){
        if(array_key_exists($key, $atts)) $ret=true;
    }
    return $ret;
}

function execCode($code, $typ, $glob=''){
    $ret='';
    $typ=strtolower($typ);
    ob_start();
    if($glob) eval($glob);
    if($typ=='js') $ret=eval("?>\n\n<script>".($code)."</script>\n\n<?php");
    else if($typ=='css') $ret=eval("?>\n\n<style>".$code."</style>\n\n<?php");
    else if($typ=='cmd'){
        $out=null;$rval=null;
        exec($code, $out, $rval);
        $ret=implode("\n", $out);
    }else if($typ=='php'){
        $op=strpos($code,'<?php');
        $cp=strpos($code,'?>');
        if($op!==false)
        if($op<$cp) $code="?>\n\n".$code."\n\n<?php";
        $ret=eval($code);
    }else{
        $code=str_replace('<php>', '<?php', $code);
        $code=str_replace('</php>', '?>', $code);
        $ret=eval("?>\n\n".$code."\n\n<?php");
    }
    $ret.=ob_get_clean();
    return $ret;
}

function execFile($file, $glob=''){
    $code=file_get_contents($file);
    $ext=substr(strrchr($file, '.'), 1);
    return execCode($code, $ext, $glob);
}

function doZy($atts, $content){
    if(is_admin()) return;
    $ret='';
    $glob='';
    if(arrKey('gvar', $atts)) $glob='global '.$atts['gvar'].';';
    if(arrKey('file', $atts)) $ret.=execFile($atts['file'], $glob);
    if(arrKey('path', $atts)) $ret.=execFile($atts['path'], $glob);
    if($content){
        $ctyp='';
        if(arrKey('code', $atts)) $ctyp=$atts['code'];
        $ret.=execCode($content, $ctyp, $glob);
    }
    if(arrKey('shortcodes', $atts)){
		remove_shortcode('zy');
		$ret = do_shortcode($ret);
		add_shortcode('zy', 'doZy');
	}
	
    return $ret;
}

add_shortcode('zy', 'doZy');
$loadCode='iw/zy-load.php';
if(file_exists($loadCode)) include_once($loadCode);
//add_shortcode('', [ $this, 'render_source_shortcode' ] );

?>